﻿using Syncfusion.UI.Xaml.Controls.Layout;
using Syncfusion.UI.Xaml.Utils;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Composition;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.UI.Xaml.Shapes;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace DockingManager_NoHeader
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Grid parent;

        Rectangle separator;

        DocumentTabPanel panel;
        public MainPage()
        {
            this.InitializeComponent();
        }

        private void CollapseHeaderPanel(object sender, object e)
        {
            if (dockingManager1 != null && dockingManager1.DocumentContainer != null)
            {
                if (parent == null)
                    parent = GetVisualChild<Grid>(dockingManager1.DocumentContainer, "PART_ItemsGrid");
                if(separator == null)
                    separator = GetVisualChild<Rectangle>(dockingManager1.DocumentContainer, "PART_RectangleStrip");
                if (parent != null && separator != null)
                {
                    parent.Visibility = Visibility.Collapsed;
                    separator.Visibility = Visibility.Collapsed;
                    dockingManager1.LayoutUpdated -= CollapseHeaderPanel;
                }
            }
        }

        private void CollapseHeader(object sender, object e)
        {
            if (dockingManager2 != null && dockingManager2.DocumentContainer != null)
            {
                if (panel == null)
                    panel = GetVisualChild<DocumentTabPanel>(dockingManager2.DocumentContainer, string.Empty);
                if (panel != null)
                {
                    panel.Visibility = Visibility.Collapsed;
                    dockingManager2.LayoutUpdated -= CollapseHeader;
                }
            }
        }

        private static T GetVisualChild<T>(DependencyObject parent, string name) where T : DependencyObject
        {
            T child = default(T);

            int numVisuals = VisualTreeHelper.GetChildrenCount(parent);
            for (int i = 0; i < numVisuals; i++)
            {
                object v = (object)VisualTreeHelper.GetChild(parent, i);
                child = v as T;
                if (child == null || (child != null && child is FrameworkElement && (child as FrameworkElement).Name != name))
                {
                    child = GetVisualChild<T>(v as DependencyObject, name);
                }
                if (child != null)
                {
                    break;
                }
            }
            return child;
        }
    }
}
